// I N C L U D E S ////////////////////////////////////////////////////////////

#include "./includes.h"
#include "./sample.h"
#include "./lw.c"
#include "./terrain.c"

// F U N C T I O N S //////////////////////////////////////////////////////////

void load_terrain()
  {
  map_seed=generate_fractal_terrain(&terrain,&edges,&windp,&ocean,&otemp,&atemp,&rain,&color_map,TERRAIN_STEPS,TERRAIN_OCEAN_RATIO,TERRAIN_RUGGEDNESS,TERRAIN_WIDTH,TERRAIN_HEIGHT,TERRAIN_DETAIL,TERRAIN_X_SQUARES,TERRAIN_Y_SQUARES,TERRAIN_CONTINENT_VAR1,TERRAIN_CONTINENT_VAR2,TERRAIN_ALT_MOD,TERRAIN_MOUNT_SCALE,TERRAIN_MIN_WIND,TERRAIN_WIND_SCALE,TERRAIN_OCEAN_SCALE,TERRAIN_AV_SIZE,TERRAIN_AV_POW1,TERRAIN_AV_POW2,SUN_SCALE,RAIN_SCALE,JUNGLE_BONUS,SWAMP_BONUS,DESERT_BONUS,PLAINS_BONUS,GRASSLAND_BONUS,FOREST_BONUS,HILLS_BONUS,TUNDRA_BONUS,GLACIER_BONUS,MOUNTAIN_BONUS);
  }

void draw_fn()
  {
  int a,b,c;
  if (new)
    {
    glClearColor( 0.40, 0.40, 0.86, 1.00 );
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    new=0;
    }
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glPushMatrix();
  glTranslatef(0,0,-900);
  glRotatef(-70,1,0,0);
  glRotatef(count,0,0,1);

  glLightfv(GL_LIGHT0, GL_POSITION, light_pos);

  glPushMatrix();
  glTranslatef(0,0,-175);
  draw_fractal_terrain(current_terrain,edges,windp,ocean,otemp,atemp,rain,color_map,x_loc,y_loc,zoom_amount,TERRAIN_DETAIL,TERRAIN_WIDTH,TERRAIN_HEIGHT,OCEAN_DETAIL,OCEAN_AMPLITUDE,OCEAN_WAVELENGTH1,OCEAN_WAVELENGTH2,OCEAN_WAVELENGTH3,OCEAN_WAVELENGTH4,OCEAN_PERIOD,EDGE_DETAIL,EDGE_AMPLITUDE);
  glPopMatrix();

  glutSwapBuffers();
  glPopMatrix();
  }

void idle_fn()
  {
  int a;
  count+=2.63;
  glutPostRedisplay();
  }

void mouse_fn(int button, int state, int x, int y)
  {
  if ((button==GLUT_RIGHT_BUTTON)&&(state==GLUT_DOWN))
    {
    map_mode++;
    if (map_mode>MAX_MAP_MODE)
      map_mode=0;
    }
  else if ((button==GLUT_LEFT)&&(state==GLUT_DOWN))
    {
    float *tmp;
    int lvl;
    lvl=pow(2,zoom_amount);
    
    x_loc=x_loc-TERRAIN_DETAIL/lvl/2+x/lvl;
    if (x_loc<0)
      x_loc=0;
    else if (x_loc>=TERRAIN_DETAIL)
      x_loc=TERRAIN_DETAIL-1;
    y_loc=y_loc-TERRAIN_DETAIL/lvl/2+y/lvl;
    if (y_loc<0)
      y_loc=0;
    else if (y_loc>=TERRAIN_DETAIL)
      y_loc=TERRAIN_DETAIL-1;
    
    zoom_amount++;
    if (zoom_amount>=MAX_ZOOM)
      zoom_amount=0;
    
    tmp=zoom(terrain,color_map,TERRAIN_DETAIL,TERRAIN_STEPS,TERRAIN_RUGGEDNESS,TERRAIN_ALT_MOD,map_seed,zoom_amount,x_loc,y_loc);
    free(current_terrain);
    current_terrain=tmp;
    }
  }

// M A I N //////////////////////////////////////////////////////////////

int main(int argc, char **argv)
  {
  int a;
  srandom(time(0));
//  srandom(1);
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInitWindowSize(SCREEN_WIDTH,SCREEN_HEIGHT);
  glutCreateWindow("Freeciv GL Terrain");
  glutDisplayFunc(draw_fn);
  glutIdleFunc(idle_fn);
  glutMouseFunc(mouse_fn);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_NORMALIZE);
  glEnable(GL_AUTO_NORMAL);
  glEnable(GL_COLOR_MATERIAL);
  glColorMaterial(GL_FRONT_AND_BACK,GL_DIFFUSE);
  glShadeModel(GL_FLAT);
//  glEnableClientState(GL_COLOR_ARRAY);
//  glEnableClientState(GL_VERTEX_ARRAY);
//  glEnableClientState(GL_NORMAL_ARRAY);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
  glMatrixMode(GL_PROJECTION);
  gluPerspective(45.0,1.0,1.0,10000.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  load_terrain();
  current_terrain=zoom(terrain,color_map,TERRAIN_DETAIL,TERRAIN_STEPS,TERRAIN_RUGGEDNESS,TERRAIN_ALT_MOD,map_seed,zoom_amount,x_loc,y_loc);
  glutMainLoop();
  }
