// I N C L U D E S ////////////////////////////////////////////////////////////

// D E F I N E S //////////////////////////////////////////////////////////////

#define SCREEN_WIDTH            512
#define SCREEN_HEIGHT           512
#define NUM_SPECS               500
#define TERRAIN_WIDTH           500.0
#define TERRAIN_HEIGHT          500.0
#define TERRAIN_X_SQUARES	50
#define TERRAIN_Y_SQUARES	50
#define TERRAIN_STEPS           9
#define TERRAIN_DETAIL		512	//2 to the TERRAIN_STEPS power
#define TERRAIN_RUGGEDNESS      60.0
#define TERRAIN_ALT_MOD		0.5
#define TERRAIN_MOUNT_SCALE	0.065
#define TERRAIN_MIN_WIND	0.05
#define TERRAIN_WIND_SCALE	5.0	//scales wind speed (coriolis)
#define TERRAIN_OCEAN_SCALE	2.0	//scales ocean current speed (coriolis)
#define TERRAIN_OCEAN_RATIO	0.500
#define TERRAIN_CONTINENT_VAR1	0.12	//Adjusting these 2 vars changes the shape of the land (lots of little islands?  rather constant, single continent?  several varied continents?)  Play around with them.
#define TERRAIN_CONTINENT_VAR2	0.0
#define TERRAIN_AV_SIZE		3	//How wide to go for coastal plains averaging
#define TERRAIN_AV_POW1		0.05	//How much to stress the point itself versus its neighbors, based on the height
#define TERRAIN_AV_POW2		0.0	//How much to stress the point itself versus its neighbors, not based on the height
#define OCEAN_DETAIL		100
#define OCEAN_AMPLITUDE		1.0	//Note: Must be proportional to the detail (higher detail=lower amplitude)
#define OCEAN_WAVELENGTH1	5.4
#define OCEAN_WAVELENGTH2	2.9
#define OCEAN_WAVELENGTH3	3.5
#define OCEAN_WAVELENGTH4	4.7
#define OCEAN_PERIOD		6
#define SUN_SCALE		1.0	//Sol at 93 million miles
#define RAIN_SCALE		1.0	//Normal laws of physics  ;)   (er... ok, made up laws that resemble normal laws)
#define JUNGLE_BONUS		0.0
#define SWAMP_BONUS		0.0
#define DESERT_BONUS		0.0
#define PLAINS_BONUS		0.0
#define GRASSLAND_BONUS		0.0
#define FOREST_BONUS		0.0
#define HILLS_BONUS		0.0
#define TUNDRA_BONUS		0.0
#define GLACIER_BONUS		0.0
#define MOUNTAIN_BONUS		0.0
#define EDGE_DETAIL		100.0	//How often it changes, in relation to a single normal polygon.
#define EDGE_AMPLITUDE		4.0	//How much it shifts, in actual units.

// S T R U C T S //////////////////////////////////////////////////////////////

typedef struct	//These will also be used to be r,g,b respectively.
  {
  float x;
  float y;
  float z;
  } coord;

typedef struct
  {
  float speed;
  float angle;
  } vector;

// G L O B A L S //////////////////////////////////////////////////////////////

float *terrain;
float *current_terrain;
int map_seed;
vector **windp;
vector **ocean;
float **otemp;
float **atemp;
float **rain;
char **color_map;
unsigned int edges;	//The random seed for the edges.
int new=0;
float count=0;
int x_loc=TERRAIN_DETAIL/2;
int y_loc=TERRAIN_DETAIL/2;
int zoom_amount=0;

// P R O T O T Y P E S ////////////////////////////////////////////////////////

void load_terrain();
void draw_fn();
void idle_fn();
void mouse_fn(int button, int state, int x, int y);








